/*
 * These defines are only applicable to the NJB1.
 */
#ifndef __PDE_DEFS__
#define  __PDE_DEFS__

typedef struct mp3player_buffer{
	size_t size;
	status_t status;
	uint32   trackid;
	uint32   offset;
	int16    datatype;
	unsigned char *buff;
	size_t   filesize;
}mp3player_buffer;


#define NJB_POWER_BATTERY       0x00 /**< If the device is running on battery */
#define NJB_POWER_AC_CHARGED    0x01 /**< If the device is running on DC 
					  and the battery is fully charged */
#define NJB_POWER_AC_CHARGING   0x03 /**< If the device is running on DC
					  and the battery is being charged */

#define NJB_XFER_BLOCK_SIZE	        0x0000FE00
#define NJB_XFER_BLOCK_HEADER_SIZE      68

#define NJB_MAX_PACKET_SIZE         8192


#define NJB_STATUS_HALT                             0x02
#define NJB_STATUS_DOWNLOAD                         0x03
#define NJB_STATUS_UPLOAD                           0x04
#define NJB_STATUS_NO_HEAP                          0x05

// CONSTANTS
#define NJB_CMD_GET_PACKET_SIZE_STATUS              (0x00+0x10a)
#define	NJB_CMD_PING								(0x01+0x10a)
#define NJB_CMD_GET_DISK_USAGE						(0x04+0x10a)
#define NJB_CMD_GET_FIRST_TRACK_TAG_HEADER			(0x06+0x10a)
#define NJB_CMD_GET_NEXT_TRACK_TAG_HEADER			(0x07+0x10a)
#define NJB_CMD_GET_STORE_TAG						(0x08+0x10a)
#define NJB_CMD_GET_TRACK_TAG						(0x09+0x10a)
#define NJB_CMD_SEND_TRACK_TAG						(0x0a+0x10a)
#define NJB_CMD_DELETE_TRACK						(0x0b+0x10a)
#define NJB_CMD_REPLACE_TRACK_TAG					(0x0c+0x10a)
#define NJB_CMD_SEND_FILE_BLOCK_WITHOUT_HEADER		(0x0d+0x10a)
#define NJB_CMD_SEND_FILE_BLOCK_WITH_HEADER			(0x0f+0x10a)
#define NJB_CMD_RECEIVE_FILE_BLOCK					(0x10+0x10a)
#define NJB_CMD_SEND_TRANSFER_COMM					(0x11+0x10a)
#define NJB_INITIALISE								(0x12+0x10a)
#define NJB_CMD_GET_NEXT_PLAYLIST_HEADER			(0x13+0x10a)
#define NJB_CMD_GET_PLAYLIST						(0x14+0x10a)
#define NJB_CMD_CREATE_PLAYLIST						(0x15+0x10a)
#define NJB_CMD_DELETE_PLAYLIST						(0x16+0x10a)
#define NJB_CMD_ADD_TRACK_TO_PLAYLIST				(0x17+0x10a)
#define NJB_CMD_CHECKN_SEND_FILE_BLOCK_STATUS		(0x1b+0x10a)
#define NJB_CMD_PLAY_TRACK							(0x1d+0x10a)
#define NJB_CMD_STOP_PLAY							(0x1e+0x10a)
#define NJB_CMD_CREATE_FILE_TAG						(0x1f+0x10a)

#define NJB_CMD_STATUS_SEND							(0x2b+0x10a)
#define NJB_CMD_RELEASE_NJB							(0x2c+0x10a)
#define NJB_CMD_GET_EAX_SIZE						(0x3a+0x10a)
#define NJB_CMD_GET_EAX								(0x24+0x10a)
#define NJB_CMD_RENAME_PLAYLIST						(0x40+0x10a)
#define NJB_CMD_SET_OWNER_STRING					(0x41+0x10a)
#define NJB_CMD_GET_OWNER_STRING					(0x42+0x10a)
#define NJB_CMD_ADD_MULTIPLE_TRACKS_TO_PLAYLIST		(0x46+0x10a)
#define NJB_CMD_GET_DATAFILE_TAG					(0x4d+0x10a)
#define NJB_CMD_VERIFY_LAST_CMD						(0xf0+0x10a)
#define NJB3_CMD_CAPTURE							0xfd
#define NJB3_CMD_RELEASE							0xfe
#define NJB_CMD_UNKNOWN_NJB3						0xff
#define NJB_VAL_GET_EAX								0x00
#define NJB_VAL_GET_EAX_UNKNOWN						0x01
#define NJB_SOUND_SET_VOLUME						0x01
#define NJB_SOUND_SET_BASS							0x02
#define NJB_SOUND_SET_TREBLE						0x03
#define NJB_SOUND_SET_MUTING						0x04
#define NJB_SOUND_SET_MIDRANGE						0x05
#define NJB_SOUND_SET_MIDFREQ						0x06
#define NJB_SOUND_SET_EAX							0x07
#define NJB_SOUND_SET_EAXAMT						0x08
#define NJB_SOUND_SET_HEADPHONE						0x09
#define NJB_SOUND_SET_REAR							0x0A
#define NJB_SOUND_SET_EQSTATUS						0x0D
#define NJB_MSG_OKAY								0x00
#define NJB_ERR_FAILED								0x01
#define NJB_ERR_DEVICE_BUSY							0x02
#define NJB_ERR_STORAGE_FULL						0x03
#define NJB_ERR_HD_GENERAL_ERROR					0x04
#define NJB_ERR_SETTIME_REJECTED					0x05
#define NJB_ERR_TRACK_NOT_FOUND			0x10
#define NJB_ERR_TRACK_EXISTS			0x11
#define NJB_ERR_TITLE_MISSING			0x12
#define NJB_ERR_CODEC_MISSING			0x13
#define NJB_ERR_SIZE_MISSING			0x14
#define NJB_ERR_IO_OPERATION_ABORTED		0x15
#define NJB_ERR_READ_WRITE_ERROR		0x16
#define NJB_ERR_NOT_OPENED			0x17
#define NJB_ERR_UPLOAD_DENIED			0x18

#define NJB_ERR_PLAYLIST_NOT_FOUND		0x20
#define NJB_ERR_PLAYLIST_EXISTS			0x21
#define NJB_ERR_PLAYLIST_ITEM_NOT_FOUND		0x22
#define NJB_ERR_PLAYLIST_ITEM_EXISTS		0x23

#define NJB_MSG_QUEUED_AUDIO_STARTED		0x30
#define NJB_MSG_PLAYER_FINISHED			0x31

#define NJB_ERR_QUEUE_ALREADY_EMPTY		0x40
#define NJB_ERR_VOLUME_CONTROL_UNAVAILABLE	0x42

#define NJB_ERR_DATA_NOT_FOUND			0x60
#define NJB_ERR_DATA_NOT_OPENED			0x67

#define NJB_ERR_PLAYER_NOT_CONNECTED		0x80
#define NJB_ERR_CANCELLED			0x81
#define NJB_ERR_PORT_NOT_AVAILABLE		0x82
#define NJB_ERR_OUT_OF_MEMORY			0x83
#define NJB_ERR_FILEOPEN_ERR			0x84
#define NJB_ERR_ITEM_NOT_FOUND			0x85
#define NJB_ERR_LOAD_COMPONENTS_FAILED		0x86
#define NJB_ERR_ID_INVALID			0x87
#define NJB_ERR_FILETYPE_ILLEGAL		0x88
#define NJB_ERR_LOADRES_FAIL			0x89
#define NJB_ERR_FORMAT_NOT_FOUND		0x8a
#define NJB_ERR_FILE_ALREADY_EXISTS		0x8b
#define NJB_ERR_LIB_CORRUPTED			0x8c
#define NJB_ERR_LIB_BUSY			0x8d
#define NJB_ERR_FILE_READ_WRITE_FAILED		0x8e
#define NJB_ERR_INVALID_FILEPATH		0x8f
#define NJB_ERR_DISKFULL_FOR_DOWNLOAD		0x90
#define NJB_ERR_FILE_PLAYONLY			0x91

#define NJB_ERR_UNDEFINED_ERR			0xff
#define NJB_ERR_NOT_IMPLEMENTED			0x100

#endif