#include "PDE.h"
int bBurstDataTransfer=0;

/**
 *  Send NJB Command to the Device
 */
status_t send_njb_command(uint32 flags, void** cookie,
			unsigned char* command,size_t clength){
	unsigned char buff[1024];
	unsigned char buff2[1024];
	
	int i=0;
	size_t len=0;
	size_t len1;
	uint16 error;
	mp3player_type *ptr=*cookie;
	usb_interface_info *ii=ptr->conf->interface[0].active;
	usb_pipe *handle_out = ii->endpoint[0].handle;
	
	status_t st;
	
	if(ptr==NULL){
		output_log("send_njb_command ... why null ?! ");
		return B_ERROR;
	}

	memset(buff,0x0,sizeof(buff));
	memcpy(buff,usb20_cmd_header,0x1f);

	from_32bit_to_njb3_bytes(clength, &buff[8]);
	len=0x1f;
	ptr->size_send+=len;
	st =usb->queue_interrupt(handle_out,buff,len,
					send_njb_command_callback, ptr);
	output_log("command header\n");
	memset(buff2,0,sizeof(buff2));
	sprintf(buff2,"sending command status:%04x  \n",st);
	output_log(buff2);
	
	if(st != B_OK){
		memset(buff,0,sizeof(buff));
		sprintf(buff,"error in bulk command header %d %02x",clength,buff[0]);
		output_log(buff);
		return B_ERROR;
	}

	ptr->size_send+=clength;


	st =usb->queue_interrupt(handle_out,
		   command,clength,
				   send_njb_command_callback, ptr);	
/*
	len = 0 ;
	while( len < clength ){
		len1 = (len + 0x40 < clength ) ? 0x40: (clength - len);
		if ( 0x20 <= len1 && len1 < 0x40  )
			len1 = 0x20;
		else if ( 0x10 <= len1 && len1 < 0x20 )
			len1 = 0x10;
		
		st =usb->queue_interrupt(handle_out,
						   command+len,len1,
						   send_njb_command_callback, ptr);	
		//sprintf(buff,"send_njb_command --- len:%04x status:%04x \n",len1,st);
		//output_log(buff);
		len +=len1;
	}
*/

	if(clength<0x100){
		memset(buff2,0,sizeof(buff2));
		output_log("command\n");
		for(i=0;i<(int)clength;++i){
			sprintf(buff2 + i*3,"%02x ",command[i]);
		}
		strcat(buff2,"\n");
		output_log(buff2);
	}
	
	if(st != B_OK){
		memset(buff,0,sizeof(buff));
		sprintf(buff,"error in send_njb_command ...  0%02x",st);
		output_log(buff);
		return B_ERROR;
	}
	return B_OK;
}

status_t send_njb_data(uint32 flags, void** cookie,
			unsigned char* command,size_t clength){
	char buff[512];

	mp3player_type *ptr=*cookie;
	usb_interface_info *ii=ptr->conf->interface[0].active;
	usb_pipe *handle_out = ii->endpoint[0].handle;
	
	status_t st;
	
	if(ptr==NULL){
		output_log("send_njb_command ... why null ?! ");
		return B_ERROR;
	}

	st =usb->queue_interrupt(handle_out,
						   command,clength,
						   send_njb_command_callback, ptr);	


	if(st != B_OK){
		memset(buff,0,sizeof(buff));
		sprintf(buff,"send_njb_command ... bulk ping 0%02x",st);
		output_log(buff);
		return B_ERROR;
	}
	return B_OK;
}

/**
 * recieve data from NJB
 * we have no data parameter because 
 * it's in the device structure
 */
status_t recv(void *cookie,
	void (*callback)(void *cookie, uint32 status, 
								  void *data, uint32 actual_len) ){
	mp3player_type *ptr=cookie;
	status_t st;
	char *buff=NULL;
	usb_interface_info *ii;
	usb_pipe *handle_in; 
	
	output_log("recv is called ... \n");
	
	if(ptr == NULL){
		output_log("recv error device_list not found!!! ");
		return B_ERROR;
	}

	ii =ptr->conf->interface[0].active;
	handle_in = ii->endpoint[1].handle;

	buff = (char*) malloc(0x2000);
	memset(buff,0,0x2000);
	st = usb->queue_interrupt(handle_in,buff,0x2000,callback, ptr);
	//free(buff);
	return st;
}

void append_packet(mp3player_type **ptr,njb_packet **pack){
	if( (*ptr)->packet == NULL){
		(*ptr)->packet= (*pack);
	}
	else{
		(*ptr)->tail->next=(*pack);
	}
	(*ptr)->tail= (*pack);		
}

/**
 * This function will clear pipe and remove all asynchronous
 * transfer.
 */
void clear_pipe(usb_interface_info *ii){
	status_t dev_status=USB_FEATURE_ENDPOINT_HALT;
	usb->cancel_queued_transfers( ii->endpoint[1].handle );
	usb->cancel_queued_transfers( ii->endpoint[0].handle );
	usb->clear_feature( &(ii->endpoint[1]) ,dev_status);
	usb->set_feature( &(ii->endpoint[1]) ,dev_status);
	usb->clear_feature( &(ii->endpoint[0]) ,dev_status);
	usb->set_feature( &(ii->endpoint[0]) ,dev_status);
}


/**
 * This callback must be used for relatively recieving small/fast commands
 * such as pinger etc
 */
void callback_normal_recv(void *cookie, uint32 status, 
								  void *data, uint32 actual_len){
	uint32 i = 0;
	njb_packet *packet;
	size_t size;
	size_t copied;
	mp3player_type *ptr= (mp3player_type*)  ( cookie );
	unsigned char buff[1024];
	unsigned char buff1[128];
	unsigned char *p_data;
	bool  bmm_error=false;
	njb_packet **p_packet;
		
	sprintf(buff,"callback_normal_recv - actual_len:%04x total:%04x\n",actual_len,ptr->size );
	output_log(buff);
	if( actual_len <= 6){
		for(i=0;i<6;++i){
			sprintf(buff + 3*i,"%02x ", ((char *)data)[i]);
		}
		strcat(buff,"\n");
		output_log(buff);
	}


	acquire_sem(ptr->lock);
	ptr->size += actual_len;
	copied = 0;
	for(i=actual_len;0<i;){
		if( (packet = (njb_packet*) malloc(sizeof(njb_packet)) ) == NULL )
			return;
		memset(packet,0,sizeof(njb_packet));
		// is it head or tail ?!
		p_packet = ( ptr->packet == NULL) ?  & (ptr->packet):
			&(ptr->tail->next);
		*p_packet=packet;
		// add new packet to the end of queue
		ptr->tail= packet;
		// increment nr_packets
		++ptr->num_packets;
		// initialize packet id and etc
		// just in case ...
		packet->packet_id=0;
		// and assign new page
		//sprintf(buff1,"njb_packet%d",ptr->num_packets);
		size=(B_PAGE_SIZE<i)?B_PAGE_SIZE:i;
		packet->size=size;
		packet->buff=(char*) malloc(size);
		if(packet->buff != NULL){
			memcpy(packet->buff,data+copied,size);	
		}
		copied += size;
		i-=size;
	}
	ptr->njb_status=NJB_STATUS_HALT;
	release_sem(ptr->lock);
	free(data);
}

/**
 * we dont use this ... dummy so far
 * this is call back function for sending njb commands
 */
void send_njb_command_callback(void *cookie, uint32 status, 
								  void *data, uint32 actual_len){
	char buff[256];
	mp3player_type *ptr= (mp3player_type*)  ( cookie );

	ptr->njb_status = NJB_STATUS_HALT;
	ptr->size_send -= actual_len;
	sprintf(buff,"send_njb_command_callback --- actual_len %04x ptr->size_send:%06x\n",actual_len,ptr->size_send);
	output_log(buff);
}

  /* Structure: 0x30 bytes
   * 4 bytes command 0x00060001U - read from database
   * 4 bytes database ID 0x00000002U - track database
   * 8 bytes previous data, initially 0xff * 8
   * 2 bytes unknown 0x0000
   * 2 bytes number of tags to request 0x0100 = 256 (I think.)
   * 2 bytes unknown 0xfffe (buffer size? 64KB - 2 bytes for status)
   *
   * 2 bytes length of metadata wishlist (which follows 0x14 originally)
   *
   * The following is then a list of metadata to be returned
   *
   * 2 bytes 0x0104 = return Title metadata  
   * 2 bytes 0x0102 = return Artist metadata
   * 2 bytes 0x0103 = return Genre metadata
   * 2 bytes 0x0101 = return Album metadata      -- 0x0A
   * 2 bytes 0x000e = return File size metadata  
   * 2 bytes 0x000b = return Locked status metadata
   * 2 bytes 0x0006 = return Codec metadata
   * 2 bytes 0x0107 = return Year metadata       -- 0x14
   * 2 bytes 0x0106 = return Track number metadata
   * 2 bytes 0x0105 = return Runlength metadata
   * OPTIONALLY:
   *   2 bytes 0x000d = return folder metadata (not requested by all apps)
   *   2 bytes 0x0007 = return Filename metadata (not requested by all apps)
   *
   * 2 bytes unknown 0x0000
   * 2 bytes unknown 0x0000
   */
// 00 00 00 06 00 0C 00 02 0D 9D 00 10 01 04 00 41
// 00 6F 00 70 00 00 00 0C 01 01 00 41 00 42 00 42 
// 00 74 00 75 00 64 00 65 00 20 00 53 00 74 00 61 
// 00 00 00 06 00 0C 00 02 75 4F 00 30 01 04 00 52
// 00 0C 00 03 01 1F 00 26 01 04 00 55 00 6E 00 64
void callback_burst_recv(void *cookie, uint32 status, 
								  void *data, uint32 actual_len){
	uint32 i = 0;
	njb_packet *packet;
	size_t size;
	size_t copied;
	mp3player_type *ptr= (mp3player_type*)  ( cookie );
	unsigned char buff[0x2000];
	unsigned char buff1[128];
	unsigned char *p_data;
	bool  bmm_error=false;
	njb_packet **p_packet;
		
	sprintf(buff,"callback_burst_recv - actual_len:%04x total:%04x\n",actual_len,ptr->size );
	output_log(buff);

	acquire_sem(ptr->lock);
	ptr->size += actual_len;
	copied = 0;
	for(i=actual_len;0<i;){
		if( (packet = (njb_packet*) malloc(sizeof(njb_packet)) ) == NULL )
			return;
		memset(packet,0,sizeof(njb_packet));
		// is it head or tail ?!
		p_packet = ( ptr->packet == NULL) ?  & (ptr->packet):
			&(ptr->tail->next);
		*p_packet=packet;
		// add new packet to the end of queue
		ptr->tail= packet;
		// increment nr_packets
		++ptr->num_packets;
		// initialize packet id and etc
		// just in case ...
		packet->packet_id=0;
		// and assign new page
		//sprintf(buff1,"njb_packet%d",ptr->num_packets);
		/*packet->packet_id= create_area(buff1, 
				(void **)& (packet->buff), 
				B_ANY_KERNEL_ADDRESS, B_PAGE_SIZE, B_CONTIGUOUS, 
				B_READ_AREA | B_WRITE_AREA);*/
		size=(B_PAGE_SIZE<i)?B_PAGE_SIZE:i;
		packet->size=size;
		packet->buff=(char*) malloc(size);
		if(packet->buff != NULL){
			memcpy(packet->buff,data+copied,size);	
		}
		copied += size;
		i-=size;
	}


	if(actual_len==0x2000){
		recv(cookie,callback_burst_recv);
		ptr->njb_status=NJB_STATUS_DOWNLOAD;
	}
	else{
		output_log("ok...burst transfer finished ...\n");
		ptr->njb_status=NJB_STATUS_HALT;
	}
	release_sem(ptr->lock);
	free(data);
}


void copy_to_userspace(char *buff,mp3player_type *ptr){
	size_t len=0;
	uint32 i;
	char str[128];
	njb_packet *packet;
	acquire_sem(dev_list_lock);
	packet=ptr->packet;
	while(packet != NULL){	
		sprintf(str,"size %03x\n",packet->size);
		output_log(str);
		memcpy(buff+len,packet->buff,packet->size);
		len += packet->size;
		packet=packet->next;
	}
	release_sem(dev_list_lock);
}