#include "PDE.h"

void from_32bit_to_njb3_bytes(uint32 val, unsigned char *dp)
{
  dp[0] = (val >> 24) & 255;
  dp[1] = (val >> 16) & 255;
  dp[2] = (val >> 8) & 255;
  dp[3] = val & 255;
}

uint16 njb3_bytes_to_16bit(unsigned char *dp)
{
  uint16 ret;

  ret = ((uint16) dp[0] << 8);
  ret = ret | (uint16) dp[1];
  return ret;
}

void from_16bit_to_njb3_bytes(uint16 val, unsigned char *dp)
{
  dp[0] = (val >> 8) & 255;
  dp[1] = val & 255;
}

void print_error(char *tag,status_t st){
	char buff[1024];
	bool b=false;
	memset(buff,0,sizeof(buff));
	
	switch(st){
		case B_USB_STATUS_SUCCESS:
			sprintf(buff,"success %s",tag);
			break;
		case B_USB_STATUS_DEVICE_CRC_ERROR:
			sprintf(buff,"CRC_ERROR");
			break;
		case B_USB_STATUS_DEVICE_TIMEOUT:
			sprintf(buff,"DEVICE_TIMEOUT");
			break;
		case B_USB_STATUS_DEVICE_STALLED:
			sprintf(buff,"DEVICE_STALLED");
			break;
		case B_USB_STATUS_IRP_CANCELLED_BY_REQUEST:
			sprintf(buff,"CANEL");
			break;
		case B_USB_STATUS_DRIVER_INTERNAL_ERROR:
			sprintf(buff,"INTERNAL ERROR");
			break;
		case B_USB_STATUS_ADAPTER_HARDWARE_ERROR:
			sprintf(buff,"HARDWARE ERROR");
			break;
		case B_USB_STATUS_ISOCH_IRP_ABORTED:
			sprintf(buff,"ISOCH ABORTED");
		default:
			sprintf(buff,"unkown error : %04x %s",st,tag);
			b=true;
			break;
	}
	//if(!b)
		kernel_debugger(buff);	
}

/**
 * swap bits from lsb <--> msb
 */
unsigned char swap(unsigned char p){
	int i=0;
	int total=0;
	int val;
	for(i=0;i<8;++i){
		val= (p>>i) & 01;
		//printf("%d ",val);
		total = total * 2 + val;
	}
	//printf("\n");
	return (char) total;
}

void output_log(char *buff){
	int id=open("/boot/home/zen.log",O_CREAT|O_APPEND|O_WRONLY);
	if(id<=0){
		return;
	}
	write(id,buff,strlen(buff));
	close(id);
}